# coding: utf-8

"""
    Agilicus API

    Agilicus API endpoints  # noqa: E501

    The version of the OpenAPI document: 2020.11.05
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class SecureAgentStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'application_services': 'list[ApplicationService]',
        'connector_info': 'list[SecureAgentConnectorInfo]'
    }

    attribute_map = {
        'application_services': 'application_services',
        'connector_info': 'connector_info'
    }

    def __init__(self, application_services=None, connector_info=None, local_vars_configuration=None):  # noqa: E501
        """SecureAgentStatus - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._application_services = None
        self._connector_info = None
        self.discriminator = None

        if application_services is not None:
            self.application_services = application_services
        if connector_info is not None:
            self.connector_info = connector_info

    @property
    def application_services(self):
        """Gets the application_services of this SecureAgentStatus.  # noqa: E501

        The list of application services associated with this secure agent  # noqa: E501

        :return: The application_services of this SecureAgentStatus.  # noqa: E501
        :rtype: list[ApplicationService]
        """
        return self._application_services

    @application_services.setter
    def application_services(self, application_services):
        """Sets the application_services of this SecureAgentStatus.

        The list of application services associated with this secure agent  # noqa: E501

        :param application_services: The application_services of this SecureAgentStatus.  # noqa: E501
        :type: list[ApplicationService]
        """

        self._application_services = application_services

    @property
    def connector_info(self):
        """Gets the connector_info of this SecureAgentStatus.  # noqa: E501

        Each item in this list informs the agent of how to connect to a connector in the agilicus infrastructure.   # noqa: E501

        :return: The connector_info of this SecureAgentStatus.  # noqa: E501
        :rtype: list[SecureAgentConnectorInfo]
        """
        return self._connector_info

    @connector_info.setter
    def connector_info(self, connector_info):
        """Sets the connector_info of this SecureAgentStatus.

        Each item in this list informs the agent of how to connect to a connector in the agilicus infrastructure.   # noqa: E501

        :param connector_info: The connector_info of this SecureAgentStatus.  # noqa: E501
        :type: list[SecureAgentConnectorInfo]
        """

        self._connector_info = connector_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecureAgentStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SecureAgentStatus):
            return True

        return self.to_dict() != other.to_dict()
